-module(element_fieldset).
%%-author('Vladimir Galunshchikov').

-include_lib("nitro/include/nitro.hrl").

-export([
  render_element/1
]).


render_element(Record) when Record#fieldset.show_if == false -> [<<>>];

render_element(Record) ->
  List = [
    %% global
    {<<"accesskey">>, Record#fieldset.accesskey},
    {<<"class">>, Record#fieldset.class},
    {<<"contenteditable">>,
       case Record#fieldset.contenteditable of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"contextmenu">>, Record#fieldset.contextmenu},
    {<<"dir">>,
       case Record#fieldset.dir of
         ltr -> "ltr";
         rtl -> "rtl";
         auto -> "auto";
         _ -> []
       end},
    
    {<<"draggable">>,
       case Record#fieldset.draggable of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"dropzone">>, Record#fieldset.dropzone},
    {<<"hidden">>,
       case Record#fieldset.hidden of
         true -> "hidden";
         _ -> []
       end},
    
    {<<"id">>, Record#fieldset.id},
    {<<"lang">>, Record#fieldset.lang},
    {<<"spellcheck">>,
       case Record#fieldset.spellcheck of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"style">>, Record#fieldset.style},
    {<<"tabindex">>, Record#fieldset.tabindex},
    {<<"title">>, Record#fieldset.title},
    {<<"translate">>,
       case Record#fieldset.contenteditable of
         true -> "yes";
         false -> "no";
         _ -> []
       end},
    
    %% spec
    {<<"disabled">>,
       case Record#fieldset.disabled of
         true -> "disabled";
         _ -> []
       end},
    
    {<<"form">>, Record#fieldset.form},
    {<<"name">>, Record#fieldset.name} | Record#fieldset.data_fields
  ],
  
  wf_tags:emit_tag(<<"fieldset">>, [
    case Record#fieldset.legend of
      [] -> [];
      B -> wf_tags:emit_tag(<<"legend">>, nitro:render(B), [])
    end,
    nitro:render(Record#fieldset.body)
    ], List).

