-module(wf_render).
%%-author('Maxim Sokhatsky').

-include_lib("nitro/include/nitro.hrl").

-export([
  render_item/1,
  render/1
]).


render_item([]) -> <<>>;
render_item(undefined) -> <<>>;
render_item(E) when erlang:element(2, E) =:= element -> wf_render_elements:render_element(E);
render_item(E) when erlang:element(2, E) =:= action  -> wf_render_actions:render_action(E);
render_item(E) -> E.

render([]) -> <<>>;
render(undefined) -> <<>>;
render(<<E/binary>>) -> E;
render(Elements) when erlang:is_list(Elements) -> [ render_item(E) || E <- Elements, E /= undefined ];
render(Elements) -> render_item(Elements).

